Redmine - Defect #27076

Cannot open attachements with special characters in filename
2017-09-26 09:30 - Markus Schenk

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Attachments Estimated time: 0.00 hour

Target version:

Resolution: Duplicate Affected version: 3.4.2

Description

When an attachment is added to a new entry with a special character in the filename, it is not possible to open the attachment after
saving (404 - document not found).

After some investigating | found that the attachment in the database uses two columns to determine the matching between
displayname and actual file on disk - 'filename' and 'disk_filename'.

An attachment with a special character in the filename (eg. tast.txt) is saved in the database like that: 'filename' => 'tast.txt',
'disk_filename' => '170926091327_3de45324.....ixt".

In redmine, the attachment name is shown as tast.txt but the underlying href link points to t%C3%C4st.txt and on open leads - as
mentioned before - to an error 404.

Now, when | update the corresponding database entry to 'filename' => 't1%C3%C4st.txt' the link then works. Unfortunately redmine
then displays the name as 't%C3%A4st.txt'.

Related issues:
Is duplicate of Redmine - Defect #26337: Can't download attachments with russ... Closed

History

#1 - 2017-09-26 11:34 - Toshi MARUYAMA

- Status changed from New to Needs feedback

Please see submissions.

#2 - 2017-09-26 12:24 - Markus Schenk

Hi Toshi,
Sorry about that; here's the missing information

| have upgraded from 3.2.5 to 3.4.2. Database is up to date (bundle exec rake db:migrate RAILS_ENV=production).
Postgres Version is 9.1.

ruby bin/about:

sh: svn: command not found
sh: darcs: command not found
sh: hg: command not found
sh: cvs: command not found
sh: bzr: command not found
sh: git: command not found
Environment:

Redmine version 3.4.2.stable

Ruby version 2.4.1-p111 (2017-03-22) [x86_64-linux]
Rails version 429

Environment production

Database adapter PostgreSQL

SCM:

Filesystem

Redmine plugins:
no plugin installed

shippet from access log
"POST /redmine/uploads.js?attachment_id=1&filename=t%C3%A4st.txt&content_type=text%2Fplain HTTP/1.1" 200
"GET /redmine/attachments/23484/t%C3%A4st.txt HTTP/1.1" 404

then after my update to the database entry
"GET /redmine/attachments/23484/t1%25C3%25A4st.txt HTTP/1.1" 200
https://www.redmine.org/projects/redmine/wiki/Submissions

Best regards
Markus
#3 - 2017-09-26 12:45 - Toshi MARUYAMA

- Status changed from Needs feedback to Closed

- Resolution set to Duplicate

Duplicate of #26337.
Why do you use Rails 4.2.9?

#4 - 2017-09-26 12:45 - Toshi MARUYAMA

- Is duplicate of Defect #26337: Can't download attachments with russian letters in name (from issue) added
#5 - 2017-09-26 12:55 - Markus Schenk
Toshi MARUYAMA wrote:

Duplicate of #26337.
Why do you use Rails 4.2.9?

Well, before updating | checked the redmine install wiki page for a recommended version. The recommended version is 4.2 so | used the most current
4.2. release.
Thank you for the fast response. | will downgrade my rails version.

#6 - 2017-09-26 16:27 - Toshi MARUYAMA

Redmine uses pinned Rails version in order to prevent behaviour change link this issue.
source:tags/3.4.2/Gemfile#l 7
How do you use Rails 4.2.97
